#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# Interpreter version: python 2.7
#
# Imports =====================================================================
from collections import namedtuple

from odictliteral import odict


# Requests ====================================================================
class LinkUpdateRequest(namedtuple("LinkUpdateRequest", ["uuid",
                                                         "doc_number",
                                                         "document_url",
                                                         "kramerius_url",
                                                         "urn_nbn",
                                                         "session_id"])):
    def __new__(cls, uuid, doc_number, document_url, session_id, urn_nbn=None,
                kramerius_url=None):
        return super(LinkUpdateRequest, cls).__new__(
            cls,
            uuid=uuid,
            doc_number=doc_number,
            document_url=document_url,
            kramerius_url=kramerius_url,
            urn_nbn=urn_nbn,
            session_id=session_id
        )

    def to_dict_xml(self):
        record = odict[
            "record": odict[
                "@session_id": self.session_id,
                "uuid": self.uuid,
                "doc_number": self.doc_number,
                "urn_nbn": self.urn_nbn,
                "kramerius_url": self.kramerius_url,
                "document_url": self.document_url,
            ]
        ]

        if not self.kramerius_url:
            del record["record"]["kramerius_url"]

        if not self.urn_nbn:
            del record["record"]["urn_nbn"]

        return record


class StatusRequest(namedtuple("StatusRequest", [])):
    pass
